#ifndef _BASIC_TYPE_HPP_
#define _BASIC_TYPE_HPP_

#include "include.hpp"

typedef class ID_index
{
protected:
  map<string, size_t> id_to_index;
  map<size_t, string> index_to_id;
public:
  bool add(string &id, size_t index);
  size_t get(string &id);
  string get(size_t index);
  size_t size();
}ID_index;

typedef class Sample_group
{
protected:
  map<string, string> sample_group;
  map<string, vector<string> > group_sample;
public:
  bool add(string &sample, string &group);
  string get_group(string &sample);
  vector<string> get_sample(string &group);
  size_t group_num();
}Sample_group;

typedef struct Order
{
  string str;
  double dbl;
  void set(string &str, double dbl);
  bool operator<(const Order &x) const;
}Order;

typedef struct Data_description
{
  ID_index probe_index;
  ID_index sample_index;
  ID_index group_index;
  Sample_group sample_group;
}Data_description;

typedef struct Probe_result
{
  gsl_vector *pvalue;
  gsl_vector *fdr;
  gsl_vector *range;
  gsl_matrix *average;
}Probe_result;

typedef struct Data_matrix
{
  gsl_matrix *data;
  gsl_matrix *valid;
  gsl_matrix *covariable;
  gsl_matrix *continuous;
}Data_matrix;

#endif
